//
//  STELSOCK	(SSL Telnet Socket)
//
//	Copyright (C) 1997,1998 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/stelsock/PREFS.C $
//			$Revision: 5 $
//			$Date: 98/01/26 11:23a $
static char VssID[] = "$Header: /sotools/stelsock/PREFS.C 5     98/01/26 11:23a Mizukosi $";


#include	<windows.h>
#include	<windows.h>
#include	<winsock.h>
#include	<stdio.h>

#include	"ssl.h"
#include	"stelsock.h"
#include	"globals.h"

//
//	Functions:
//		GetClientStat
//		SetApplication
//		GetPEMFiles
//

/////////////////////////////////////////////////////////////////////////
//
//	GetClientStat
//		Get the negotiation mode of this application.
//
DWORD GetClientStat()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	DWORD dwBuf;
	int   res;
	char  szProgramPath[_MAX_PATH];

	if (GetModuleFileName(NULL, szProgramPath, _MAX_PATH) == 0){
		return FALSE;
	}

	if (RegOpenKeyEx(HKEY_CURRENT_USER, STELSOCK_STAT_SUBKEY, 0, KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS){
		SetApplication(szProgramPath);
		return DEFAULT_VALUE;
	}

	res = FALSE;

	dwType   = REG_DWORD;
	dwLength = sizeof(dwBuf);
	if (RegQueryValueEx(hKey, szProgramPath, NULL, &dwType, (LPBYTE)&dwBuf, &dwLength) == ERROR_SUCCESS){
		res = TRUE;
	}

	RegCloseKey(hKey);

	if (res == FALSE){
		SetApplication(szProgramPath);
		return DEFAULT_VALUE;
	} else {
		return dwBuf;
	}
}


///////////////////////////////////////////////////////////////////////////
//
//	SetApplication
//		Set default value to the registory for this application.
//
BOOL SetApplication(char *szProgramPath)
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	DWORD dwBuf;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, STELSOCK_STAT_SUBKEY, 0, "", REG_OPTION_NON_VOLATILE,
						KEY_WRITE, NULL, &hKey, &dwType) != ERROR_SUCCESS){
		return FALSE;
	}

	dwType   = REG_DWORD;
	dwLength = sizeof(dwBuf);
	dwBuf    = DEFAULT_VALUE;
	RegSetValueEx(hKey, szProgramPath, 0, dwType, (LPBYTE)&dwBuf, dwLength);

	RegCloseKey(hKey);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////
//
//	GetPEMFiles
//
int GetPEMFiles()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, STELSOCK_CERTS_SUBKEY, 0, KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS){
		SetCerts();
		return FALSE;
	}

	// Load Cert File
	dwType   = REG_SZ;
	dwLength = sizeof(gCertFile);
	RegQueryValueEx(hKey, CERT_FILE_VALNAME, NULL, &dwType, gCertFile, &dwLength);

	// Load Key File
	dwType   = REG_SZ;
	dwLength = sizeof(gKeyFile);
	RegQueryValueEx(hKey, KEY_FILE_VALNAME, NULL, &dwType, gKeyFile, &dwLength);

	// Load CA File
	dwType   = REG_SZ;
	dwLength = sizeof(gCAFile);
	RegQueryValueEx(hKey, CA_FILE_VALNAME, NULL, &dwType, gCAFile, &dwLength);

	// Load CA Path
	dwType   = REG_SZ;
	dwLength = sizeof(gCAPath);
	RegQueryValueEx(hKey, CA_PATH_VALNAME, NULL, &dwType, gCAPath, &dwLength);

	RegCloseKey(hKey);

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////
//
//	SetCerts
//
int SetCerts()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	char  szDefCerts[1];

	if (RegCreateKeyEx(HKEY_CURRENT_USER, STELSOCK_CERTS_SUBKEY, 0, "", REG_OPTION_NON_VOLATILE,
						KEY_WRITE, NULL, &hKey, &dwType) != ERROR_SUCCESS){
		return FALSE;
	}

	dwType   = REG_SZ;
	dwLength = 1;
	szDefCerts[0] = 0;
	RegSetValueEx(hKey, CERT_FILE_VALNAME, 0, dwType, szDefCerts, dwLength);
	RegSetValueEx(hKey, KEY_FILE_VALNAME,  0, dwType, szDefCerts, dwLength);
	RegSetValueEx(hKey, CA_FILE_VALNAME,   0, dwType, szDefCerts, dwLength);
	RegSetValueEx(hKey, CA_PATH_VALNAME,   0, dwType, szDefCerts, dwLength);

	RegCloseKey(hKey);

	return TRUE;
}
